// Generated by CoffeeScript 1.7.1
(function() {
  var appConfigSrvc, buildMatcher, configuration, matcherify, prefixify;

  configuration = {
    baseUrl: "",
    date: "2014-04-07",
    version: "0.1.16",
    views: {
      home: {
        label: "home",
        route: "/app/home",
        url: "/app/home/",
        template: "/static/app/view/home.html",
        controller: "HomeCtlr"
      },
      otherwise: {
        label: "console",
        route: "/app/console",
        url: "/app/console/",
        template: "/static/app/view/console.html",
        controller: "ConsoleCtlr"
      },
      tabs: [
        {
          label: "console",
          route: "/app/console",
          url: "/app/console/",
          template: "/static/app/view/console.html",
          controller: "ConsoleCtlr"
        }, {
          label: "project",
          route: "/app/project",
          url: "/app/project/",
          template: "/static/app/view/project.html",
          controller: "ProjectCtlr"
        }
      ]
    },
    preferences: {
      debug: false,
      verbose: false,
      saltApi: {
        scheme: "",
        host: "",
        port: 0,
        prefix: "",
        eauth: "pam"
      },
      fetchGrains: false,
      preloadJobCache: false,
      highStateCheck: {
        performCheck: false,
        intervalSeconds: 300
      }
    }
  };

  prefixify = function(views, base) {
    var item, name, view, _i, _len;
    for (name in views) {
      item = views[name];
      if (item.label != null) {
        item.route = base + item.route;
        item.url = base + item.url;
        item.template = base + item.template;
      } else {
        for (_i = 0, _len = item.length; _i < _len; _i++) {
          view = item[_i];
          view.route = base + view.route;
          view.url = base + view.url;
          view.template = base + view.template;
        }
      }
    }
    return views;
  };

  buildMatcher = function(route) {
    var chunk, chunks, i, matcher, _i, _len;
    chunks = route.split("/");
    for (i = _i = 0, _len = chunks.length; _i < _len; i = ++_i) {
      chunk = chunks[i];
      if (chunk.match("^:\\w+$") != null) {
        chunks[i] = "\\w*";
      }
    }
    matcher = "^" + chunks.join("/") + "$";
    return matcher;
  };

  matcherify = function(views) {
    var item, name, view, _i, _len;
    for (name in views) {
      item = views[name];
      if (item.label != null) {
        item.matcher = buildMatcher(item.route);
      } else {
        for (_i = 0, _len = item.length; _i < _len; _i++) {
          view = item[_i];
          view.matcher = buildMatcher(view.route);
        }
      }
    }
    return views;
  };

  configuration.views = prefixify(configuration.views, configuration.baseUrl);

  configuration.views = matcherify(configuration.views);

  appConfigSrvc = angular.module("appConfigSrvc", []);

  appConfigSrvc.constant('Configuration', configuration);

}).call(this);
