// Generated by CoffeeScript 1.7.1

/*
Application State Data Service
Provides shared global application state data
usage:

mainApp = angular.module("MainApp", [... 'appDataSrvc'])


mainApp.controller 'MyCtlr', ['$scope', ...,'AppData',
    ($scope,...,AppData) ->

    $scope.appData = AppData.getData()
    AppData.setData
        loggedIn: true
 */

(function() {
  var __hasProp = {}.hasOwnProperty;

  angular.module("appDataSrvc", ['appConfigSrvc', "appUtilSrvc"]).factory("AppData", [
    'Configuration', 'Itemizer', function(Configuration, Itemizer) {
      var COMMANDS, EVENTS, JOBS, MINIONS, appData, base, servicer;
      appData = {};
      base = Configuration.baseUrl;
      JOBS = 'jobs';
      MINIONS = 'minions';
      EVENTS = 'events';
      COMMANDS = 'commands';
      appData[JOBS] = new Itemizer();
      appData[COMMANDS] = new Itemizer();
      appData[MINIONS] = new Itemizer();
      appData[EVENTS] = new Itemizer();
      servicer = {
        getCommands: function() {
          return this.get(COMMANDS);
        },
        getJobs: function() {
          return this.get(JOBS);
        },
        getMinions: function() {
          return this.get(MINIONS);
        },
        getEvents: function() {
          return this.get(EVENTS);
        },
        getAll: function() {
          return appData;
        },
        update: function(data) {
          var key, val;
          for (key in data) {
            if (!__hasProp.call(data, key)) continue;
            val = data[key];
            appData[key] = val;
          }
          return appData;
        },
        clear: function() {
          appData = {};
          return appData;
        },
        get: function(key) {
          return appData[key];
        },
        set: function(key, val) {
          appData[key] = val;
          return val;
        },
        del: function(key) {
          if (key in appData) {
            delete appData[key];
          }
          return appData;
        },
        keys: function() {
          var key;
          return (function() {
            var _results;
            _results = [];
            for (key in appData) {
              if (!__hasProp.call(appData, key)) continue;
              _results.push(key);
            }
            return _results;
          })();
        },
        clearSaltData: function() {
          this.set(COMMANDS, new Itemizer());
          this.set(JOBS, new Itemizer());
          this.set(MINIONS, new Itemizer());
          this.set(EVENTS, new Itemizer());
        }
      };
      return servicer;
    }
  ]);

}).call(this);
